import { select, 
        csv, 
        scaleLinear, 
        max, 
        scaleBand, 
        axisLeft, 
        axisBottom,
        format
       } from 'd3';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');
 
const render = data => {
	console.log(data);
  
  const xValue = d => d.population;
  const yValue = d => d.country;
  const margin = {top: 90, right: 50, left: 150, bottom: 70};
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  //Take away=> xScale returns a VALUE!!!!!
  //Need to understand this more :(
  const xScale = scaleLinear() //understand max() func
  							.domain([0, max(data, xValue)])
  							.range([0, innerWidth]);
	
  const yScale = scaleBand()
  							 .domain(data.map(yValue))
  							 .range([0, innerHeight])
  							 .padding(0.1);
  
  const xAxisTickFormat = d =>
  			format('.3s')(d).replace('G','B'); //How ()() worked?
  
  const yAxis = axisLeft(yScale);
  const xAxis = axisBottom(xScale).tickFormat(xAxisTickFormat)
  							.tickSize(-innerHeight);
  
  console.log(yScale.domain());
  console.log(xScale(100000000000));
  console.log(xScale.domain());
  console.log(xScale.range());
  
  
  
  const g = svg.append('g')
  		.attr('transform', `translate(${margin.left},${margin.top})`);			
  
  g.append('g').call(yAxis)
    .selectAll('.domain, .tick line')
    .remove();
  
  const xAxisG = g.append('g').call(xAxis)
  		.attr('transform', `translate(0,${innerHeight})`);
  
  xAxisG.select('.domain').remove();
  xAxisG.append('text')
  	.attr('class', 'axis-label')
  	.attr('x', innerWidth / 2)
  	.attr('y', margin.bottom - 10)
  	.attr('fill', 'black')
  	.text('Population');
  
  g.selectAll('rect').data(data)
  	.enter().append('rect') //how xScale works when we are passing a single value (d.population)?
  	.attr('y', d => yScale(yValue(d))) //how it worked? yValue(d) = d.country ? How?
  	.attr('width', d => xScale(xValue(d))) //how xValue(d) = d.population ?
  	.attr('height', yScale.bandwidth())
  
  g.append('text')
  	.attr('class', 'title')
  	.attr('y', -10)
  	.text('Top 10 Most Populous countries');
};

csv('data.csv').then(data =>{
	data.forEach(d =>{
  	d.population = +d.population * 1000;
  });
  render(data);
});